
Redmine - Defect #4787

Gannt to PNG - CJK (Chinese, Japanese and Korean)  characters appear as ?

2010-02-10 08:44 - Jeffrey Jones

Status: Closed Start date: 2010-02-10

Priority: Normal Due date:  

Assignee: Toshi MARUYAMA % Done: 100%

Category: Gantt Estimated time: 0.00 hour

Target version: 2.2.0   

Resolution: Fixed Affected version:  

Description

When exporting a gantt chart to png format all Japanese (hiragana,katakana and kanji) characters are replaced with ? characters.

This is using RMagick 2.12.2 and the libmagick9-dev provided with Ubuntu 9.10.

Being able to export to PNG would relieve some of the problems we are facing with the inability to export to PDF (As discussed in

issue #61 )

(Also would it be useful to add an "Exporters" category? I am not sure what to file this under)

Related issues:

Related to Redmine - Defect #6505: PDF export broken with Japanese (Gannt and... Closed 2010-09-27

Related to Redmine - Defect #61: Broken character encoding in pdf export Closed

Related to Redmine - Patch #3231: patch for broken character problem on png-e... Closed 2009-04-23

Related to Redmine - Feature #69: Textilized description in PDF Closed

Related to Redmine - Feature #5638: Use Bundler (Gemfile) for gem management Closed 2010-06-02

Related to Redmine - Defect #13781: CJK(Chinese/Japanese/Korean) characters a... Closed

Has duplicate Redmine - Defect #6506: Gantt chart export to PDF/PNG works inc... Closed 2010-09-27

Associated revisions

Revision 10890 - 2012-11-28 11:11 - Toshi MARUYAMA

add configuration of RMagcik font for CJK (Chinese, Japanese and Korean) (#4787)

Contributed by Jun NAITOH.

Revision 10892 - 2012-11-28 12:00 - Toshi MARUYAMA

fix comment of RMagcik font configuration (#4787)

History

#1 - 2010-02-16 10:00 - Jeffrey Jones

- % Done changed from 0 to 10

Looks like this is a font issue.

I edited /lib/redmine/helpers/gantt.rb and hacked in the following

gc = Magick::Draw.new

gc.font = "/usr/share/fonts/truetype/msttcorefonts/gothic.ttf" # New Line - Explicitly declare font

# Subjects

 This is an ugly hard-coded hack that points to a font that I know for sure is UTF-8 Japanese character compatible and it works.

So the question now is how to make this something that can be merged into redmine itself and works on all platforms.

Maybe we could make an administration option that allows us to select the fonts we desire for our exports? (When using PDF/PNG?)

#2 - 2010-03-22 11:41 - Ki Won Kim

Symptoms are the same, and I was modified gantt.rb by your hacked code.

thanks a lot.

2025-05-02 1/5

https://www.redmine.org/issues/61


Jeffrey Jones wrote:

When exporting a gantt chart to png format all Japanese (hiragana,katakana and kanji) characters are replaced with ? characters.

This is using RMagick 2.12.2 and the libmagick9-dev provided with Ubuntu 9.10.

Being able to export to PNG would relieve some of the problems we are facing with the inability to export to PDF (As discussed in issue #61 )

(Also would it be useful to add an "Exporters" category? I am not sure what to file this under)

#3 - 2010-10-03 15:07 - Mischa The Evil

- Category set to Gantt

#4 - 2011-04-09 12:43 - Toshi MARUYAMA

- Subject changed from Gannt to PNG - Japanese characters appear as ? to Gannt to PNG - CJK (Chinese, Japanese and Korean)  characters

appear as ?

#5 - 2012-01-25 05:59 - Namho Kim

- File gantt_korean.png added

That's right. For example Gannt include Korean like belows.

#6 - 2012-01-25 06:01 - Namho Kim

That's right. For example Gannt include Korean like belows.

 

#7 - 2012-02-01 16:30 - Jun NAITOH

- File png_rmagick_font_r8745.patch added

- File rmagick_font.png added

This issue is font setting problem.

I wrote selectable RMagcik font patch.

This patch add RMagick font selector of Display tab in Setting.
If you want to show Japanese, so please select Japanese Font.

 

I tested on RMagick 2.13.1 on CentOS 6, RMagick 2.12.0 on Windows XP.

#8 - 2012-02-01 16:36 - Toshi MARUYAMA

- Assignee set to Toshi MARUYAMA

#9 - 2012-02-01 17:58 - Etienne Massip

Please don't make this a new setting, just force the police font to what would fit well if possible?

#10 - 2012-02-02 00:08 - Toshi MARUYAMA

- Assignee deleted (Toshi MARUYAMA)

#11 - 2012-02-02 03:17 - Toshi MARUYAMA

- File user-pref.png added

- File user-pref-r8745.patch added

This is a patch using user preference.

 user-pref.png 

#12 - 2012-02-02 09:44 - Etienne Massip

I can't see why a font would be a user preference?? This should be automatic, who wants to select a specific font to export a chart? I just want to click

and get my Gantt chart exported as a image as it it rendered in browser, period.

Please don't add too much complexity.

#13 - 2012-02-02 10:35 - Toshi MARUYAMA

Etienne Massip wrote:

This should be automatic

 There is no standard font in Japanese.

Windows: MS Mincho, MS Gothic

MacOS: HIRAGINO

Linux: Nothing

Unicode has Unified problem.

http://en.wikipedia.org/wiki/CJK_Unified_Ideographs

So, CJK font cannot be defined automatically.

#14 - 2012-02-02 10:46 - Toshi MARUYAMA

On Redmine 1.3, CJK PDF fonts are hard-coded.

source:tags/1.3.0/lib/redmine/export/pdf.rb#L52

Redmine 1.3 uses non embedded fonts for CJK PDF.

So, PDF reader uses alternate fonts if there is no fonts on client.

But, rmagick processes on server.

So, we cannot hard-coded and defined fonts at locale files (config/locales/ja.yml).

#15 - 2012-02-02 11:07 - Etienne Massip

Can't you add a setting to embed fonts into exported file?
#16 - 2012-02-02 11:14 - Toshi MARUYAMA

Etienne Massip wrote:

Can't you add a setting to embed fonts into exported file?

 It is difficult that user/administrator finds fonts name on server.

On Note-12 user-pref.png, font name is "IPAGothic-Regular".

#17 - 2012-02-09 04:00 - Namho Kim

- File redmine-gantt_kr.png added

Korean is OK, using the above patch.

 

#18 - 2012-02-12 16:25 - Jun NAITOH

Toshi MARUYAMA wrote:

This is a patch using user preference.

 I'm checked. I think this patch is better than my patch.

#19 - 2012-02-25 04:32 - Jun NAITOH

- File png_rmagick_font_path_r8987.patch added

Etienne Massip wrote:

Please don't add too much complexity.
 OK. I tried another approach.

This patch add a configurable path of RMagick in configuration.yml.

#20 - 2012-11-15 16:57 - Go MAEDA

Current PNG output is of no use in CJK. Font name must be set to address the problem but we cannot know what font is installed in a system

because standard CJK font is different by operating system.

NAITOH's patch (png_rmagick_font_path_r8987.patch) seems smart approach to deal with the problem because there's no ui change.

It wishes strongly that the patch is merged to trunk to make Redmine more useful.

#21 - 2012-11-19 13:36 - Toshi MARUYAMA

- File png_rmagick_font_path_r10851.patch added

This is a patch of note-19 png_rmagick_font_path_r8987.patch rebased to trunk r10851.

You can apply it to 2.1-stable r10848 (2.1.3).

#22 - 2012-11-28 13:31 - Toshi MARUYAMA

- Status changed from New to Closed

- Assignee set to Toshi MARUYAMA

- Target version set to 2.2.0

- % Done changed from 10 to 100

- Resolution set to Fixed

I have added comment to note-21 patch and committed in trunk r10890 and r10892.

#23 - 2014-08-29 13:27 - Daniel Felix

Etienne Massip wrote:

Please don't make this a new setting, just force the police font to what would fit well if possible?

 Well I would agree to that point. Our users won't be able to easily determine the right font on languages they don't even know.

#24 - 2014-08-30 10:46 - Toshi MARUYAMA

- Related to Defect #13781: CJK(Chinese/Japanese/Korean) characters are not shown in PDF on non CJK locales added

Files

gantt_korean.png 23.3 KB 2012-01-25 Namho Kim

png_rmagick_font_r8745.patch 2.01 KB 2012-02-01 Jun NAITOH

rmagick_font.png 23.8 KB 2012-02-01 Jun NAITOH

user-pref.png 33.9 KB 2012-02-02 Toshi MARUYAMA

user-pref-r8745.patch 3.03 KB 2012-02-02 Toshi MARUYAMA

redmine-gantt_kr.png 50.1 KB 2012-02-09 Namho Kim

png_rmagick_font_path_r8987.patch 1.07 KB 2012-02-25 Jun NAITOH

png_rmagick_font_path_r10851.patch 1.3 KB 2012-11-19 Toshi MARUYAMA
